api/urls.py
from .views import *
from django.urls import path
urlpatterns=[
    path('all-contents/',content_api),
    path('all-feedbacks/',all_feedback_api),
    path('add-content/<id>/',add_content_file_api),
    path('add-feedback/',add_feedback_api),
    path('login/',login_request_api),
    path('register/murid/',register_murid_api),
    path('register/guru/',register_guru_api),
    path('all-courses/', all_courses_api, name='all_courses'),
    path('participants/murid/', participants_murid_json_api),
    path('participants/murid-user/<id>', participants_murid_user_api),
    path('participants/guru/', participants_pengajar_json_api),
    path('participants/guru-user/<id>', participants_pengajar_user_api),
    path('participants/', participants_json_api),
    path('course/contents/<id>/', contents_json_api),
    path('course/summary/<id>/', summary_json_api),
    path('course/sections/<id>/', sections_api),
    path('course/sections/add/<id>/', add_section_api),
    path('section/<id>/add/<sectionid>/', add_section_post_api),
    path('section/<id>/', sections_posts_api),
    path('user/<id>/', view_json_api),
    path('update_user/<id>/', update_user_api),
    path('forum/main/<id>/', forum_post_api),
    path('forum/createpost/<courseid>/<usrid>', create_post_api),
    path('forum/createreply/<id>/<usrid>', reply_api),
    path('forum/<id>/', reply_api),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
    path('register/', views.register, name='register'),
    path('register/murid', views.murid_register.as_view(), name='register_murid'),
    path('register/pengajar', views.pengajar_register.as_view(), name='register_pengajar'),
    path('login/', views.login_request, name='login'),
    path('logout/',views.logout_view, name='logout'),
    path('add-course/', views.add_course, name='add_course'),
    path('all-courses/', views.all_courses, name='all_courses'),
    path('course/', views.all_courses, name='course'),
    path('course/<id>/', views.course_detail, name='course<id>'),
    path('course/<id>/contentsjson', views.contents_json, name='course<id>json'),
    path('course/<id>/participantsjson/', views.participants_json, name='course<id>participants'),
    path('course/<id>/add-section/', views.course_add_section, name='course<id>addsection'),
    path('course/<id>/add-summary/', views.course_add_summary, name='course<id>addsummary'),
    path('course/<id>/add-post/<sectionid>/', views.course_add_post, name='course<id>addpost<sectionid>'),
    path('course/<id>/unenroll/', views.course_unenroll, name='course<id>unenroll'),
    path('course-summary/<id>/', views.course_summary, name='course<id>summary'),
    path('course-summary/<id>/summaryjson', views.summary_json, name='course<id>summary'),
    path('course-summary/<id>/enroll/', views.course_enroll, name='course<id>enroll'),
    path('coursesbyme/', views.coursesbyme, name='coursesbyme'),
    path('coursestaken/', views.coursestaken, name='coursestaken'),
    path('profile/', views.detail_view, name='profile'),
    path('profileupdate/<id>/', views.update_view, name='profileupdate<id>'),
    path('profile/<id>/viewjson', views.view_json, name='profilejson'),
]

project_uts/urls.py
from django.contrib import admin
from django.urls import include, path
from  rest_framework.routers import DefaultRouter
from ujian.views import *

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('helpdesk/', include('helpdesk.urls')),
    path('forum/', include('forum.urls')),
    path('content/', include('content.urls')),
    path('quiz/', include('ujian.urls')),
    path('api/', include('api.urls')),
]

templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta charset="UTF-8">
    <!-- Compiled and minified CSS -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">


    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
    <style>
      @import url('https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,100;0,300;0,400;0,500;0,700;0,900;1,100;1,300;1,400;1,500;1,700;1,900&display=swap');
      body{
        font-family: 'Roboto', sans-serif;
      }
    </style>
    
  <!-- Scriptsss -->
  <script src="https://code.jquery.com/jquery-3.3.1.min.js"> </script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
  <script>
    $(document).ready(function(){
      $('.sidenav').sidenav();
      $(".dropdown-trigger").dropdown();
    });


  </script>
  
  
  {% block meta %}
  {% endblock meta %}
</head>



<body>
  <!-- dropdown helpdesk -->
  <ul id="nav-help" class="dropdown-content">
    <li><a href="/helpdesk/" class="purple-text text-accent-4 "> 
      <i class="material-icons left black-text">chat</i>Help</a></li>
    <li><a href="/helpdesk/contact-admin" class="purple-text text-accent-4 "><i class="material-icons left black-text">call</i>Contacts
      </a></li>
    <li><a  class="purple-text text-accent-4 "  href="/helpdesk/faq">FAQ
      <i class="material-icons left black-text">question_answer</i></a></li>
  </ul>

  {% if request.user.is_authenticated %}
  <!-- dropdown profile -->
  <ul id="nav-profile" class="dropdown-content">
    <li><a  class="waves-effect purple-text"  href="/profile">Profile
      <i class="material-icons right">face</i></a></li>
    <li><a  class="red-text text-accent-3 waves-effect" href="/logout">Logout
      <i class="material-icons right">logout</i></a>
      
    </li>
  </ul>

  {% endif%}
<!-- dropdown menu -->
<ul id="nav-menu" class="dropdown-content">
  <li><a  class="purple-text waves-effect"  href="/all-courses">All Courses</a></li>
               
  {% if request.user.is_pengajar %}
  <li><a  class="waves-effect purple-text "  href="/add-course">Add Course</a></li>
  <li><a  class="waves-effect purple-text "  href="/coursesbyme">My Courses</a></li>
  <li><a  class="waves-effect purple-text "  href="/quiz/lecturer-home-quiz/">My Quiz</a></li>
  
  {% endif %}
  {% if request.user.is_murid %}
  <li><a  class="waves-effect purple-text "  href="/coursestaken">My Courses</a></li>
  <li><a  class="waves-effect purple-text "  href="/quiz/">My Quiz</a></li>
  <!-- <li><a  class="tab btn  waves-effect  "  href="/profile">Profile</a></li> -->
  {% endif %}
  {% if request.user.is_superuser %}
    <li><a  class="waves-effect purple-text"  href="/helpdesk/list">List Feedback</a></li>
  {% endif %}
    
  </li>
</ul>


    <div class="navbar-fixed">
        <nav  class="purple nav-extended">
            <div class="nav-wrapper">
            <div class="container">
                
                <a href="/" class="brand-logo">Learning App</a>
                <a href="#" data-target="mobile-bar" class="sidenav-trigger"><i class="material-icons  waves-effect ">menu</i></a>
                {% if not request.user.is_authenticated %}
                <ul id="nav-mobile" class="right hide-on-med-and-down">
                    <li><a  class="tab btn waves-effect purple lighten-5 hoverable"  href="/login">
                      <span class="deep-purple-text text-darken-2 "> Login </span> </a></li>
                    <li><a  class="tab btn  waves-effect waves-light purple darken-4 hoverable " href="/register">Register</a></li>

                    <li><a class="dropdown-trigger btn purple lighten-5 hoverable waves-effect" href="#!" data-target="nav-help">
                      <i class="material-icons left black-text">feedback</i>
                      <span class="deep-purple-text text-darken-2 "> Help </span><i class="material-icons right black-text">arrow_drop_down</i></a></li>

                </ul>
                {% elif request.user.is_authenticated %}
                <ul id="nav-mobile" class="right hide-on-med-and-down">
                    
                    <li><a class="dropdown-trigger btn waves-light purple darken-4 hoverable waves-effect" href="#!" data-target="nav-menu">
                      <i class="material-icons left ">menu</i>
                      <span class="white-text  ">
                       Menu </span>
                       <i class="material-icons right ">arrow_drop_down</i></a></li>

                    <li><a class="dropdown-trigger btn waves-light purple darken-4 hoverable waves-effect" href="#!" data-target="nav-profile">
                      <i class="material-icons left ">account_circle</i>
                      <span class="white-text  ">
                       {{request.user.username}} </span>
                       <i class="material-icons right ">arrow_drop_down</i></a></li>

                    <li><a class="dropdown-trigger btn purple lighten-5 hoverable waves-effect" href="#!" data-target="nav-help">
                      <i class="material-icons left black-text">feedback</i>
                      <span class="deep-purple-text text-darken-2 "> Help </span><i class="material-icons right black-text">arrow_drop_down</i></a></li>
                      
                </ul>
                  </ul>
                  {% endif %}
                  
                  
            </div>
        </div>
    </nav>
</div>
    
      <ul class="sidenav" id="mobile-bar">
      
        {% if not request.user.is_authenticated %}
        <li><a  class="tab btn  waves-effect  "  href="/login">Login</a></li>
        <li><a  class="tab btn  waves-effect " href="/register">Register</a></li>
        {% elif request.user.is_authenticated %}
        <li><a  class="btn white darken-1 waves-effect purple-text"  href="/profile">{{request.user.username}}
          <i class="material-icons right">face</i></a></li>
        <li><a  class="tab btn red darken-1  waves-effect " href="/logout">Logout</a></li>
        <li><a  class="tab btn  deep-purple darken-2 waves-effect  waves-light hoverable "  href="/all-courses">All Courses</a></li>
        {% if request.user.is_superuser %}
        <li><a  class="tab btn waves-effect deep-purple darken-1 "  href="/helpdesk/list">List Feedback</a></li>
        {% endif %} 
        {% if request.user.is_pengajar %}
        <li><a  class="tab btn  waves-effect  "  href="/add-course">Add Course</a></li>
        <li><a  class="tab btn  waves-effect "  href="/coursesbyme">My Courses</a></li>
        <li><a  class="tab btn  waves-effect "  href="/quiz/lecturer-home-quiz/">My Quiz</a></li>
        {% endif %} 
        {% if request.user.is_murid %}
        <li><a  class="tab btn waves-effect purple white-text "  href="/coursestaken">My Courses</a></li>
        
        {% endif %} 

          
        {% endif %}
        <li><div class="divider "></div></li>

          
        <li><a href="/helpdesk/" class="purple-text text-accent-4 "> 
          <i class="material-icons left black-text">chat</i>Help</a></li>
        <li><a href="/helpdesk/contact-admin" class="purple-text text-accent-4 "><i class="material-icons left black-text">call</i>Contacts
          </a></li>
        <li><a  class="purple-text text-accent-4 "  href="/helpdesk/faq">FAQ
          <i class="material-icons left black-text">question_answer</i></a></li>

      </ul>
    



  <div class="container">
      {% block content %}
      {% endblock content %}

  </div>
  <!-- <script src="{% static 'js/sidebar.js' %}"></> -->

</body>

</html>

templates/base2.html
{% load static %}

<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <link rel="shortcut icon" type="image/png" href="{% static 'favicon.ico' %}"/>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">

    <script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
    <link rel="stylesheet" href="{% static 'style.css' %}">

    {% block scripts %}
    {% endblock scripts %}

    <title>Quiz | {% block title %}{% endblock title %}</title>
  </head>

  <body>
    {%include "base.html"%}
    <div class="container mt-3">
        {% block content %}
        {% endblock content %}
    </div>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
  </body>
</html>

templates/header.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Header</title>

{% endblock meta %}
{% block content %}
<nav class="navbar navbar-expand-lg navbar-light bg-light shadow mb-3 bg-body rounded">
    <div class="container-sm">
        <a class="navbar-brand" href="/">Navbar</a>
  <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNavDropdown" aria-controls="navbarNavDropdown" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse " id="navbarNavDropdown">
      <ul class="navbar-nav ms-auto d-flex">
    <!-- <li class="nav-item">
        <a class="nav-link active" aria-current="page" href="#">Home</a>
    </li> -->
    <li class="nav-item">
        <a class="nav-link" href="#">Login</a>
    </li>
    <li class="nav-item">
        <a class="nav-link" href="{% url 'main:register' %}">Register</a>
      </li>
    </ul>
  </div>
</div>
</nav>

  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
  {% endblock content %}
  